local L = LibStub("AceLocale-3.0"):GetLocale("SliceCommander")
local _G = getfenv(0)

function SliceCommander:UNIT_HEALTH(_, unitID)
	if unitID == "player" then
		SliceCommander:HealthBar('HEALTH')
	elseif unitID == "target" then
		SliceCommander:HealthBar('THEALTH')
	end
end

function SliceCommander:PLAYER_REGEN_DISABLED()
	SliceCommander:HealthBar('HEALTH')
	SliceCommander:HealthBar('THEALTH')
	SliceCommander:TestDP()
	SliceCommander:Energy()
end

--1:unknown 2:sourceGUID 3:sourceName 4:sourceFlags 5:sourceFlags2 6:destGUID 7:destName 8:destFlags 9:destFlags2
--10:spellId 11:spellName 12:spellSchool
--13:extraSpellID 14:extraSpellName	15:extraSchool
function SliceCommander:COMBAT_LOG_EVENT_UNFILTERED()
	local _, event, _, _, sourceName, _, _, _, _, _, _, _, _, _, extraSpellID = CombatLogGetCurrentEventInfo()
	if event == "SPELL_INTERRUPT" and sourceName == UnitName("player") and _G['SC'].SET.kickEnable == true then
		local message = _G['SC'].SET.kickMessage
		if _G['SC'].SET.kickSpell then
			local link = GetSpellLink(extraSpellID)
			message = link..' > '..message
		end
		if _G['SC'].SET.kickChannel['INSTANCE_CHAT'] and IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
			SendChatMessage(message, 'INSTANCE_CHAT')
		elseif _G['SC'].SET.kickChannel['RAID'] and IsInRaid() then
			SendChatMessage(message, 'RAID')
		elseif _G['SC'].SET.kickChannel['PARTY'] and IsInGroup() then
			SendChatMessage(message, 'PARTY')
		elseif _G['SC'].SET.kickChannel['SAY'] then
			SendChatMessage(message, 'SAY')
		end
	end
end

function SliceCommander:UNIT_POWER_FREQUENT(_, unit, powerType)
	if unit == "player" and powerType == "COMBO_POINTS" then
		SliceCommander:SetComboPts()
		SliceCommander:ChangeAnchor()
	end
	if unit == "player" and powerType == "ENERGY" then
		SliceCommander:Energy()--energy value and play sound if necessary
	end
end

function SliceCommander:PLAYER_TARGET_CHANGED()
	SliceCommander:HealthBar('THEALTH')
	SliceCommander:ChangeAnchor()
end

function SliceCommander:UNIT_SPELLCAST_START(_, unit, _, spellId)
	if unit == "player" and _G['SC'].SET.displayGCD then
		local start, dur = GetSpellCooldown(spellId)
		if dur and dur > 0 and dur <= 1.5 then
			_G['SC'].OTHER['AS']['expire'] = start+dur
			_G['SC'].OTHER['AS']['obj']:SetMinMaxValues(0, dur)
			_G['SC'].OTHER['AS']['obj']:Show()
		end
	end
end

function SliceCommander:UNIT_MAXPOWER(_, UnitId, PowyerType)
	if _G['SC'].initDone and UnitId == "player" and PowyerType == "COMBO_POINTS" then
		--Update CP Bar
		local maxCP = UnitPowerMax("player", Enum.PowerType.ComboPoints)

		for i = 1, maxCP do
			_G['SC'].BARS['CP']['obj'].combos[i].bg:SetVertexColor(unpack(_G['SC'].SET.CP[maxCP][i]))
		end
		for i = 1, 10 do
			_G['SC'].BARS['CP']['obj'].combos[i].bg:Hide()
		end

		SliceCommander:SetTimersHeight(_G['SC'].SET.TimerHeight)
		SliceCommander:SetWidth(_G['SC'].SET.Width)
		SliceCommander:SetComboPts()
	end
end

function SliceCommander:UNKNOWN()
	--DO NOTHING TRY TO AVOID UBKOWN CALL...
end

function SliceCommander:ACTIVE_TALENT_GROUP_CHANGED()
	if _G['SC'].initDone then
		SliceCommander:SetSparks()--MOVE SPARK for the current spec

		local aSpec = GetSpecialization()
		_G['SC'].OTHER['POISON']['obj'].button:SetAttribute("spell1", SC_SPELL[_G['SC'].SET.poison.mh[aSpec]])
		_G['SC'].OTHER['POISON']['obj'].button:SetAttribute("spell2", SC_SPELL[_G['SC'].SET.poison.oh[aSpec]])
		if _G['SC'].SET.poison.oh == 'none' then
			_G['SC'].OTHER['POISON']['obj'].button:SetAttribute("spell2", nil)
		end
	end
end

function SliceCommander:AZERITE_ESSENCE_UPDATE()
	SliceCommander:SetEssence()
end

function SliceCommander:PLAYER_LOGIN()
	_G['SC'].preventSound = true
	SliceCommander:TestCurrentVersion()
	_G['SC'].initDone = true
	_G['SC'].order = 0
	_G['SC'].maxPos = 0
	_G['SC'].maxCDPos = 0
	_G['SC'].previouKyrCount = {false, false, false, false, false}
	SliceCommander:TestValueOptions()
	SliceCommander:SetEssence()
	SliceCommander:InitConfigurationTable()
	SliceCommander:InitFont()
	SliceCommander:InitConstantValue()
	SliceCommander:CreateCore()
	SliceCommander:InitBar()
	SliceCommander:InitIcon()
	SliceCommander:InitGCDBar()
	SliceCommander:ApplyConf()
	SliceCommander:SetEssence()
	SliceCommander:ChangeAnchor()
	_G['SC'].preventSound = false
	collectgarbage()
	UpdateAddOnMemoryUsage()
	print('|cffc14f2cSlice|r|cff40a740Commander|r v'..GetAddOnMetadata("SliceCommander", "Version")..' ('..L["memory use"]..':'..floor(GetAddOnMemoryUsage("SliceCommander"))..' kb)')
end

function SliceCommander:OnInitialize()
	if _G['SC'] == nil then
		_G['SC'] = {}
	end
	
	_G['SC'].initDone = false
	local _, englishClass = UnitClass("player")
	
	local spec = GetSpecialization()
	if spec == 5 and englishClass == "ROGUE" then --newly created toon
		print(L["You have to choose a spec to use SliceCommander."])
		SliceCommander:OnDisable()
		return 0
	end
	
	if englishClass == "ROGUE" then
		SliceCommander_LoadTukuiApi()
		SliceCommander:LoadPopup()
		SliceCommander:Contruct_StaticPopups()

		--HAS TO BE Pixel Perfect scale
		SliceCommander:UIScale('PLAYER_LOGIN')

		SliceCommander:RegisterEvent('UI_SCALE_CHANGED', 'UIScale')
		SliceCommander:RegisterEvent("PLAYER_REGEN_DISABLED")
		SliceCommander:RegisterEvent("PLAYER_REGEN_ENABLED", "PLAYER_REGEN_DISABLED")
		SliceCommander:RegisterEvent("UNIT_POWER_FREQUENT")
		SliceCommander:RegisterEvent("PLAYER_TARGET_CHANGED")
		SliceCommander:RegisterEvent("UNIT_HEALTH")
		SliceCommander:RegisterEvent("PLAYER_LOGIN")
		SliceCommander:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		SliceCommander:RegisterEvent("UNIT_SPELLCAST_START")
		SliceCommander:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED","UNIT_SPELLCAST_START")
		SliceCommander:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		SliceCommander:RegisterEvent("PLAYER_TALENT_UPDATE", "ACTIVE_TALENT_GROUP_CHANGED")
		SliceCommander:RegisterEvent("UNIT_MAXPOWER")
		SliceCommander:RegisterEvent("AZERITE_ESSENCE_UPDATE")
	else
		SliceCommander:OnDisable()
		return 0
	end
end

function SliceCommander:TestKYRIAN()
	local _, spellId, count, displayKyrCP
	local cpCounts = {}
	local kyrBuff = {
		[SC_SPELLID['ER2']] = 2, -- 2nd CP
		[SC_SPELLID['ER3']] = 3, -- 3rd CP
		[SC_SPELLID['ER4']] = 4, -- 4th CP
		[SC_SPELLID['ER5']] = 5, -- 5th CP
	}
	
	for k, v in pairs(kyrBuff) do
		_, _, _, _, _, _, _, _, _, spellId = SliceCommander:UnitAura("player", k, "HELPFUL PLAYER")
		if spellId then
			cpCounts[v] = true
		else
			cpCounts[v] = false
		end 
	end
	
	for count,displayKyrCP in pairs(cpCounts) do
		if displayKyrCP ~= _G['SC'].previouKyrCount[count] then
			if _G['SC'].previouKyrCount[count] then
				_G['SC'].BARS['CP']['obj'].combos[count].anim:Stop()
			end
			if displayKyrCP then
				_G['SC'].BARS['CP']['obj'].combos[count].anim:Play()
			end
			_G['SC'].previouKyrCount[count] = displayKyrCP
		end
	end
end

function SliceCommander:OnUpdate()
	SliceCommander:Latency()--timer reference and latency
	SliceCommander:GCD()--GCD
	SliceCommander:TargetThreat()--Threat

	for k, v in pairs(_G['SC'].BARS) do
		if _G['SC'].BARS[k]['type'] ~= nil then--1=BUFF 2=DEBUFF 3=SELF DEBUF
			if _G['SC'].BARS[k]['type'] == 1 or _G['SC'].BARS[k]['type'] == 2 or _G['SC'].BARS[k]['type'] == 3 then
				SliceCommander:UpdateBar(k, 'BARS')
			elseif _G['SC'].BARS[k]['type'] == 4 then--CD
				SliceCommander:AbilityCDBar(k)
			elseif _G['SC'].BARS[k]['type'] == 5 then--CHARGE CD
				SliceCommander:ChargeAbilityCDBar(k)
			elseif _G['SC'].BARS[k]['type'] == 6 then--MULTIPLE BUFF BAR
				SliceCommander:MultipleAbilityBar(k)
			end
		end
	end
	for k, v in pairs(_G['SC'].ICONS) do
		if _G['SC'].ICONS[k]['type'] ~= nil then--1=BUFF 2=DEBUFF 3=SELF DEBUF
			if _G['SC'].ICONS[k]['type'] == 1 or _G['SC'].ICONS[k]['type'] == 2 or _G['SC'].ICONS[k]['type'] == 3 then
				SliceCommander:UpdateBar(k, 'ICONS')
			elseif _G['SC'].ICONS[k]['type'] == 4 then--CD
				--SliceCommander:AbilityCDIcon(k)
			elseif _G['SC'].ICONS[k]['type'] == 5 then--CHARGE CD
				--SliceCommander:ChargeAbilityCDBIcon(k)
			elseif _G['SC'].ICONS[k]['type'] == 6 then--MULTIPLE BUFF BAR
				--SliceCommander:MultipleAbilityIcon(k)
			end
		end
	end

	SliceCommander:TestKYRIAN()--DP Icon
	SliceCommander:TestDP()--DP Icon
end